-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-- Written by Kimberly L. Tripp - all rights reserved.
-- 
-- For more scripts and sample code, check out 
-- 	http://www.SQLSkills.com
--
-- Disclaimer - Thoroughly test this script, execute at your own risk.
-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

SET STATISTICS IO ON
-- Turn Graphical Showplan ON (Ctrl+K)

USE CREDIT
go

CREATE INDEX ChargeMemberNo ON dbo.Charge(member_no, charge_no)

SET STATISTICS IO ON
SET STATISTICS TIME ON
-- Index Seek + Bookmark Lookup
SELECT * FROM Charge
WHERE member_no < 100  --369 I/Os

-- Table scan
SELECT * FROM Charge
WHERE member_no < 1000  --9305 I/Os

SELECT * FROM Charge
WHERE member_no < 500  --TS

-- What if the data isn't in cache
DBCC DROPCLEANBUFFERS
go
DECLARE @Start	datetime, @End datetime
SELECT @Start = getdate()
SELECT * FROM Charge
WHERE member_no < 241  --TS
SELECT @End = getdate()
SELECT 'TotalTime(ms)' = datediff(ms, @Start, @End)
go

DBCC DROPCLEANBUFFERS
go
DECLARE @Start	datetime, @End datetime
SELECT @Start = getdate()
SELECT * FROM Charge
WHERE member_no < 240  --TS
SELECT @End = getdate()
SELECT 'TotalTime(ms)' = datediff(ms, @Start, @End)
go

